do not require unused partial dirs in 'source' (Closes: #633510)
[ntk/apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
3# we all like colorful messages
4CERROR="\e[1;31m" # red
5CWARNING="\e[1;33m" # yellow
6CMSG="\e[1;32m" # green
7CINFO="\e[1;96m" # light blue
8CDEBUG="\e[1;94m" # blue
9CNORMAL="\e[0;39m" # default system console color
10CDONE="\e[1;32m" # green
11CPASS="\e[1;32m" # green
12CFAIL="\e[1;31m" # red
13CCMD="\e[1;35m" # pink
14
15msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
18msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
29
30# enable / disable Debugging
fc89263e
DK
31MSGLEVEL=${MSGLEVEL:-3}
32if [ $MSGLEVEL -le 0 ]; then
33 msgdie() { true; }
34fi
35if [ $MSGLEVEL -le 1 ]; then
36 msgwarn() { true; }
37 msgnwarn() { true; }
38fi
39if [ $MSGLEVEL -le 2 ]; then
40 msgmsg() { true; }
41 msgnmsg() { true; }
39cc8228
DK
42 msgtest() { true; }
43 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
44 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
45 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
fc89263e
DK
46fi
47if [ $MSGLEVEL -le 3 ]; then
48 msginfo() { true; }
49 msgninfo() { true; }
50fi
51if [ $MSGLEVEL -le 4 ]; then
52 msgdebug() { true; }
53 msgndebug() { true; }
54fi
55msgdone() {
56 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
57 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
58 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
59 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
60 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
61 true;
62 else
63 echo "${CDONE}DONE${CNORMAL}" >&2;
64 fi
65}
8d876415
DK
66
67runapt() {
68 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
7d0627b6
DK
69 if [ -f ./aptconfig.conf ]; then
70 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
4b2a4ab8
MV
71 elif [ -f ../aptconfig.conf ]; then
72 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
7d0627b6
DK
73 else
74 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
75 fi
8d876415
DK
76}
77aptconfig() { runapt apt-config $*; }
78aptcache() { runapt apt-cache $*; }
79aptget() { runapt apt-get $*; }
80aptftparchive() { runapt apt-ftparchive $*; }
1f8b2599 81aptkey() { runapt apt-key $*; }
ec7f904e 82aptmark() { runapt apt-mark $*; }
158fda31
DK
83dpkg() {
84 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
85}
b6b5a542
DK
86aptitude() {
87 if [ -f ./aptconfig.conf ]; then
88 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
89 elif [ -f ../aptconfig.conf ]; then
90 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
91 else
92 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
93 fi
94}
8d876415 95
b720d0bd
DK
96addtrap() {
97 CURRENTTRAP="$CURRENTTRAP $1"
98 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
99}
8d876415
DK
100
101setupenvironment() {
75954ae2 102 TMPWORKINGDIRECTORY=$(mktemp -d)
8f8169ac 103 local TESTDIR=$(readlink -f $(dirname $0))
3cbbda3c 104 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
8f8169ac 105 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
8d876415
DK
106 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
107 local OLDWORKINGDIRECTORY=$(pwd)
b720d0bd 108 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
8d876415 109 cd $TMPWORKINGDIRECTORY
cd725954 110 mkdir rootdir aptarchive keys
8d876415 111 cd rootdir
b29c3712
DK
112 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
113 mkdir -p var/cache var/lib var/log
cffea9af 114 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
2c6baa5a 115 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
8f8169ac
DK
116 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
117 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
118 else
119 touch var/lib/dpkg/status
120 fi
cd725954 121 touch var/lib/dpkg/available
8d876415
DK
122 mkdir -p usr/lib/apt
123 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
124 cd ..
2c6baa5a 125 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
8f8169ac
DK
126 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
127 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 128 fi
4a4ea26c
AM
129 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
130 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
131 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 132 fi
cd725954
DK
133 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
134 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
cffea9af 135 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 136 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
137 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
138 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
f425d4d5 139 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
cffea9af
DK
140 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
141 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
142 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
143 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
144 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
145 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
2c085486 146 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
8d876415 147 export LC_ALL=C
7f52cf7b 148 export PATH="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
8d876415
DK
149 msgdone "info"
150}
151
152configarchitecture() {
153 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
154 echo "APT::Architecture \"$1\";" > $CONFFILE
155 shift
156 while [ -n "$1" ]; do
157 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
158 shift
159 done
160}
161
75954ae2 162setupsimplenativepackage() {
ce9864a8
DK
163 local NAME="$1"
164 local ARCH="$2"
165 local VERSION="$3"
166 local RELEASE="${4:-unstable}"
167 local DEPENDENCIES="$5"
168 local DESCRIPTION="$6"
b7899b00
DK
169 local SECTION="${7:-others}"
170 local DISTSECTION
171 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
172 DISTSECTION="main"
173 else
174 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
175 fi
ce9864a8
DK
176 local BUILDDIR=incoming/${NAME}-${VERSION}
177 mkdir -p ${BUILDDIR}/debian/source
178 cd ${BUILDDIR}
179 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
180 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
181 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
182
183 * Initial release
184
b7899b00
DK
185 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
186 test -e debian/control || echo "Source: $NAME
187Section: $SECTION
ce9864a8
DK
188Priority: optional
189Maintainer: Joe Sixpack <joe@example.org>
190Build-Depends: debhelper (>= 7)
191Standards-Version: 3.9.1
192
875bcb36
DK
193Package: $NAME" > debian/control
194 if [ "$ARCH" = 'all' ]; then
195 echo "Architecture: all" >> debian/control
196 else
197 echo "Architecture: any" >> debian/control
198 fi
ce9864a8
DK
199 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
200 if [ -z "$DESCRIPTION" ]; then
201 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
202 If you find such a package installed on your system,
203 YOU did something horribly wrong! They are autogenerated
204 und used only by testcases for APT and surf no other propose…" >> debian/control
205 else
206 echo "Description: $DESCRIPTION" >> debian/control
207 fi
b7899b00
DK
208 test -e debian/compat || echo "7" > debian/compat
209 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 210 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
211 cd - > /dev/null
212}
213
214buildsimplenativepackage() {
215 local NAME="$1"
216 local ARCH="$2"
217 local VERSION="$3"
218 local RELEASE="${4:-unstable}"
219 local DEPENDENCIES="$5"
220 local DESCRIPTION="$6"
221 local SECTION="${7:-others}"
d67004e0 222 local PRIORITY="${8:-optional}"
75954ae2
DK
223 local DISTSECTION
224 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
225 DISTSECTION="main"
226 else
227 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
228 fi
5a635ee4 229 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
b761356f 230
18331adf 231 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
b761356f
DK
232 mkdir -p $BUILDDIR/debian/source
233 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
234 echo "#!/bin/sh
235echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
236
237 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
238 echo "$NAME ($VERSION) $RELEASE; urgency=low
239
240 * Initial release
241
242 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
243 echo "Source: $NAME
244Section: $SECTION
d67004e0 245Priority: $PRIORITY
b761356f
DK
246Maintainer: Joe Sixpack <joe@example.org>
247Standards-Version: 3.9.1
248
875bcb36
DK
249Package: $NAME" > ${BUILDDIR}/debian/control
250 if [ "$ARCH" = 'all' ]; then
251 echo "Architecture: all" >> ${BUILDDIR}/debian/control
252 else
253 echo "Architecture: any" >> ${BUILDDIR}/debian/control
254 fi
b761356f
DK
255 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
256 if [ -z "$DESCRIPTION" ]; then
257 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
258 If you find such a package installed on your system,
259 YOU did something horribly wrong! They are autogenerated
260 und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
261 else
262 echo "Description: $DESCRIPTION" >> ${BUILDIR}/debian/control
263 fi
264 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
265 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
b761356f 266 for SRC in $SRCS; do
5a635ee4 267 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
b761356f 268 done
84aa13f4
DK
269
270 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
271 rm -rf ${BUILDDIR}/debian/tmp
272 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
273 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
274 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
275 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
276 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
277
278 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
279 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
280 done
281
13845042
DK
282 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
283 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
284 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
5a635ee4 285 rm -rf "${BUILDDIR}"
b761356f 286 msgdone "info"
75954ae2
DK
287}
288
289buildpackage() {
290 local BUILDDIR=$1
291 local RELEASE=$2
292 local SECTION=$3
293 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
294 cd $BUILDDIR
295 if [ "$ARCH" = "all" ]; then
296 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
297 fi
b7899b00
DK
298 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
299 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
5ed56f93 300 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 301 cd - > /dev/null
b7899b00 302 for PKG in $PKGS; do
75954ae2 303 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
304 done
305 for SRC in $SRCS; do
75954ae2 306 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 307 done
cffea9af 308 msgdone "info"
ce9864a8
DK
309}
310
311buildaptarchive() {
ce9864a8
DK
312 if [ -d incoming ]; then
313 buildaptarchivefromincoming $*
314 else
315 buildaptarchivefromfiles $*
316 fi
317}
318
319createaptftparchiveconfig() {
320 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
321 if [ -z "$ARCHS" ]; then
322 # the pool is empty, so we will operate on faked packages - let us use the configured archs
323 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
324 fi
ce9864a8
DK
325 echo -n 'Dir {
326 ArchiveDir "' >> ftparchive.conf
327 echo -n $(readlink -f .) >> ftparchive.conf
328 echo -n '";
329 CacheDir "' >> ftparchive.conf
330 echo -n $(readlink -f ..) >> ftparchive.conf
331 echo -n '";
b7899b00
DK
332 FileListDir "' >> ftparchive.conf
333 echo -n $(readlink -f pool/) >> ftparchive.conf
334 echo -n '";
335};
336Default {
bc33e0f0
DK
337 Packages::Compress ". gzip bzip2 lzma xz";
338 Sources::Compress ". gzip bzip2 lzma xz";
339 Contents::Compress ". gzip bzip2 lzma xz";
b7080ced 340 Translation::Compress ". gzip bzip2 lzma xz";
18331adf 341 LongDescription "false";
ce9864a8
DK
342};
343TreeDefault {
344 Directory "pool/";
345 SrcDirectory "pool/";
346};
347APT {
348 FTPArchive {
349 Release {
350 Origin "joesixpack";
351 Label "apttestcases";
352 Suite "unstable";
353 Description "repository with dummy packages";
354 Architectures "' >> ftparchive.conf
355 echo -n "$ARCHS" >> ftparchive.conf
356 echo 'source";
357 };
358 };
359};' >> ftparchive.conf
b7899b00
DK
360 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
361 echo -n 'tree "dists/' >> ftparchive.conf
362 echo -n "$DIST" >> ftparchive.conf
363 echo -n '" {
ce9864a8
DK
364 Architectures "' >> ftparchive.conf
365 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
366 echo -n 'source";
367 FileList "' >> ftparchive.conf
368 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
369 echo -n '";
370 SourceFileList "' >> ftparchive.conf
371 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
372 echo -n '";
373 Sections "' >> ftparchive.conf
374 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
375 echo '";
ce9864a8 376};' >> ftparchive.conf
b7899b00 377 done
ce9864a8
DK
378}
379
380buildaptftparchivedirectorystructure() {
b7899b00
DK
381 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
382 for DIST in $DISTS; do
383 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
384 for SECTION in $SECTIONS; do
385 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
386 for ARCH in $ARCHS; do
387 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
388 done
389 mkdir -p dists/${DIST}/${SECTION}/source
390 mkdir -p dists/${DIST}/${SECTION}/i18n
391 done
ce9864a8 392 done
ce9864a8
DK
393}
394
9b78cda6
DK
395insertpackage() {
396 local RELEASE="$1"
397 local NAME="$2"
398 local ARCH="$3"
399 local VERSION="$4"
400 local DEPENDENCIES="$5"
d67004e0
DK
401 local PRIORITY="${6:-optional}"
402 local ARCHS=""
403 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
404 if [ "$arch" = "all" ]; then
405 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
406 else
407 ARCHS="$arch"
408 fi
409 for BUILDARCH in $ARCHS; do
410 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
411 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
412 touch aptarchive/dists/${RELEASE}/main/source/Sources
413 local FILE="${PPATH}/Packages"
414 echo "Package: $NAME
415Priority: $PRIORITY
9b78cda6 416Section: other
2c085486 417Installed-Size: 42
9b78cda6 418Maintainer: Joe Sixpack <joe@example.org>
d67004e0 419Architecture: $arch
2c085486 420Version: $VERSION
d67004e0
DK
421Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
422 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
423 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
9b78cda6
DK
424 If you find such a package installed on your system,
425 YOU did something horribly wrong! They are autogenerated
426 und used only by testcases for APT and surf no other propose…
427" >> $FILE
d67004e0 428 done
9b78cda6
DK
429 done
430}
431
dfc2b1be
DK
432insertinstalledpackage() {
433 local NAME="$1"
434 local ARCH="$2"
435 local VERSION="$3"
436 local DEPENDENCIES="$4"
d67004e0 437 local PRIORITY="${5:-optional}"
dfc2b1be 438 local FILE="rootdir/var/lib/dpkg/status"
d67004e0
DK
439 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
440 echo "Package: $NAME
dfc2b1be 441Status: install ok installed
d67004e0 442Priority: $PRIORITY
dfc2b1be
DK
443Section: other
444Installed-Size: 42
445Maintainer: Joe Sixpack <joe@example.org>
d67004e0 446Architecture: $arch
dfc2b1be 447Version: $VERSION" >> $FILE
d67004e0
DK
448 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
449 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
dfc2b1be
DK
450 If you find such a package installed on your system,
451 YOU did something horribly wrong! They are autogenerated
452 und used only by testcases for APT and surf no other propose…
453" >> $FILE
d67004e0 454 done
dfc2b1be
DK
455}
456
457
ce9864a8 458buildaptarchivefromincoming() {
3cbbda3c 459 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
460 cd aptarchive
461 [ -e pool ] || ln -s ../incoming pool
462 [ -e ftparchive.conf ] || createaptftparchiveconfig
463 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 464 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 465 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
466 cd - > /dev/null
467 msgdone "info"
9b78cda6 468 generatereleasefiles
ce9864a8
DK
469}
470
471buildaptarchivefromfiles() {
3cbbda3c 472 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
473 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
474 msgninfo "\t${line} file… "
475 cat ${line} | gzip > ${line}.gz
476 cat ${line} | bzip2 > ${line}.bz2
477 cat ${line} | lzma > ${line}.lzma
b7080ced 478 cat ${line} | xz > ${line}.xz
8d876415 479 msgdone "info"
9b78cda6
DK
480 done
481 generatereleasefiles
482}
483
484generatereleasefiles() {
485 msgninfo "\tGenerate Release files… "
fe0f7911 486 local DATE="${1:-now}"
9b78cda6 487 if [ -e aptarchive/dists ]; then
18331adf
DK
488 for dir in $(find ./aptarchive/dists -mindepth 3 -maxdepth 3 -type d -name 'i18n'); do
489 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Patterns::='Translation-*' > $dir/Index
490 done
9b78cda6 491 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
35faae11 492 local CODENAME="$(echo "$dir" | cut -d'/' -f 4)"
2c085486
DK
493 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Suite="${CODENAME}" -o APT::FTPArchive::Release::Codename="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
494 if [ "$CODENAME" = "experimental" -o "$CODENAME" = "experimental2" ]; then
35faae11
DK
495 sed -i '/^Date: / a\
496NotAutomatic: yes' $dir/Release
497 fi
9b78cda6
DK
498 done
499 else
500 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 501 fi
fe0f7911
DK
502 if [ "$DATE" != "now" ]; then
503 for release in $(find ./aptarchive -name 'Release'); do
504 touch -d "$1" $release
505 done
8d876415 506 fi
b7899b00 507 msgdone "info"
8d876415
DK
508}
509
b7899b00
DK
510setupdistsaptarchive() {
511 local APTARCHIVE=$(readlink -f ./aptarchive)
512 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
513 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
514 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
515 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
516 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
517 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
518 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
519 msgdone "info"
520 done
521}
522
523setupflataptarchive() {
ce9864a8 524 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
525 if [ -f ${APTARCHIVE}/Packages ]; then
526 msgninfo "\tadd deb sources.list line… "
527 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
528 msgdone "info"
529 else
530 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
531 fi
532 if [ -f ${APTARCHIVE}/Sources ]; then
533 msgninfo "\tadd deb-src sources.list line… "
534 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
535 msgdone "info"
536 else
537 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
538 fi
b7899b00
DK
539}
540
541setupaptarchive() {
542 buildaptarchive
543 if [ -e aptarchive/dists ]; then
544 setupdistsaptarchive
545 else
546 setupflataptarchive
547 fi
f213b6ea 548 signreleasefiles
cd725954 549 msgninfo "\tSync APT's cache with the archive… "
8d876415 550 aptget update -qq
cd725954 551 msgdone "info"
8d876415
DK
552}
553
f213b6ea
DK
554signreleasefiles() {
555 local SIGNER="${1:-Joe Sixpack}"
556 msgninfo "\tSign archive with $SIGNER key… "
557 local SECKEYS=""
558 for KEY in $(find keys/ -name '*.sec'); do
559 SECKEYS="$SECKEYS --secret-keyring $KEY"
560 done
561 local PUBKEYS=""
562 for KEY in $(find keys/ -name '*.pub'); do
563 PUBKEYS="$PUBKEYS --keyring $KEY"
564 done
565 for RELEASE in $(find aptarchive/ -name Release); do
566 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
fe0f7911 567 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
f213b6ea
DK
568 done
569 msgdone "info"
570}
571
572changetowebserver() {
573 if which weborf > /dev/null; then
574 weborf -xb aptarchive/ 2>&1 > /dev/null &
b720d0bd 575 addtrap "kill $!;"
c5bcc607
DK
576 elif which lighttpd > /dev/null; then
577 echo "server.document-root = \"$(readlink -f ./aptarchive)\"
578server.port = 8080
579server.stat-cache-engine = \"disable\"" > lighttpd.conf
580 lighttpd -t -f lighttpd.conf >/dev/null || msgdie 'Can not change to webserver: our lighttpd config is invalid'
581 lighttpd -D -f lighttpd.conf 2>/dev/null >/dev/null &
582 addtrap "kill $!;"
583 else
584 msgdie 'You have to install weborf or lighttpd first'
585 return 1
f213b6ea 586 fi
c5bcc607
DK
587 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
588 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
589 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
590 done
591 return 0
f213b6ea
DK
592}
593
594checkdiff() {
8d876415
DK
595 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
596 if [ -n "$DIFFTEXT" ]; then
597 echo
598 echo "$DIFFTEXT"
599 return 1
600 else
601 return 0
602 fi
603}
604
75954ae2
DK
605testfileequal() {
606 local FILE="$1"
607 shift
608 msgtest "Test for correctness of file" "$FILE"
609 if [ -z "$*" ]; then
f213b6ea 610 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 611 else
f213b6ea 612 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
613 fi
614}
615
8d876415
DK
616testequal() {
617 local COMPAREFILE=$(mktemp)
b720d0bd 618 addtrap "rm $COMPAREFILE;"
8d876415
DK
619 echo "$1" > $COMPAREFILE
620 shift
621 msgtest "Test for equality of" "$*"
f213b6ea 622 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
623}
624
685625bd
DK
625testequalor2() {
626 local COMPAREFILE1=$(mktemp)
627 local COMPAREFILE2=$(mktemp)
628 local COMPAREAGAINST=$(mktemp)
b720d0bd 629 addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
685625bd
DK
630 echo "$1" > $COMPAREFILE1
631 echo "$2" > $COMPAREFILE2
632 shift 2
633 msgtest "Test for equality OR of" "$*"
634 $* 2>&1 1> $COMPAREAGAINST
f213b6ea
DK
635 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
636 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
637 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
638 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
685625bd
DK
639 msgfail )
640}
641
8d876415 642testshowvirtual() {
edc0ef10 643 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
644 local PACKAGE="$1"
645 shift
646 while [ -n "$1" ]; do
647 VIRTUAL="${VIRTUAL}
edc0ef10 648N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
649 PACKAGE="${PACKAGE} $1"
650 shift
651 done
652 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
653 VIRTUAL="${VIRTUAL}
4bec02c2 654N: No packages found"
8d876415 655 local COMPAREFILE=$(mktemp)
b720d0bd 656 addtrap "rm $COMPAREFILE;"
8d876415
DK
657 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
658 eval `apt-config shell ARCH APT::Architecture`
659 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 660 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
661}
662
663testnopackage() {
664 msgtest "Test for non-existent packages" "apt-cache show $*"
665 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
666 if [ -n "$SHOWPKG" ]; then
667 echo
668 echo "$SHOWPKG"
669 msgfail
670 return 1
671 fi
672 msgpass
673}
01a6e24c
DK
674
675testdpkginstalled() {
676 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
87bc1c45
DK
677 local PKGS="$(dpkg -l $* | grep '^i' | wc -l)"
678 if [ "$PKGS" != $# ]; then
01a6e24c
DK
679 echo $PKGS
680 dpkg -l $* | grep '^[a-z]'
681 msgfail
682 return 1
683 fi
684 msgpass
685}
686
5cf733e1
DK
687testdpkgnotinstalled() {
688 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
87bc1c45 689 local PKGS="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
01a6e24c
DK
690 if [ "$PKGS" != 0 ]; then
691 echo
692 dpkg -l $* | grep '^[a-z]'
693 msgfail
694 return 1
695 fi
696 msgpass
697}
ec7f904e
DK
698
699testmarkedauto() {
700 local COMPAREFILE=$(mktemp)
701 addtrap "rm $COMPAREFILE;"
702 if [ -n "$1" ]; then
703 msgtest 'Test for correctly marked as auto-installed' "$*"
704 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
705 else
706 msgtest 'Test for correctly marked as auto-installed' 'no package'
c98fb5e0 707 echo -n > $COMPAREFILE
ec7f904e
DK
708 fi
709 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
710}
89a1aa5d
DK
711
712pause() {
713 echo "STOPPED execution. Press enter to continue"
714 local IGNORE
715 read IGNORE
716}